 
<?php

use \Firebase\JWT\JWT;
use Firebase\JWT\Key;

class JWTHandler
{
    private $secretKey;

    public function __construct()
    {
        $this->secretKey =  getenv('JWT_SECRET');
    }

    public function generateToken($data)
    {
        $duration =  time() + (30 * 24 * 60 * 60); //30 days
        // $duration = time() + (60 * 60);// 1hour
        $payload = [
            'iss' => SITELINK,
            'iat' => time(),
            'exp' =>  $duration, 
            'data' => $data
        ];

        return JWT::encode($payload, $this->secretKey, 'HS256');
    }

    public function validateToken($token)
    {
        try {

            $decoded = JWT::decode($token,  new Key($this->secretKey, 'HS256'));
            return (array) $decoded->data;
        } catch (Exception $e) {
            return false;
        }
    }
}
