<?php

require_once __DIR__ . '/require.php';

$jsonData = json_decode(file_get_contents("php://input"));



//TODO: POST REQUEST
if ($_SERVER['REQUEST_METHOD'] === 'POST') {

    if (!isset($jsonData->refresh_token)) {
        Response::send(400, ['error' => 'Refresh token is required']);
        exit();
    }

    // Get the refresh token from the request
    $refreshToken = $jsonData->refresh_token;

    try {
        //TODO VALIDATE TOKEN BEFORE GRANTING ACCESS TO ANY DATA
        $token =  CommonFunctions::getBearerToken();
        $rest =  $jwtHandler->validateToken($token);
        if ($rest == false) {
            Response::send(400, ['error' => 'Refresh token is required']);
            exit;
        }

        // Retrieve the data from the decoded refresh token 
        $grant = [
            'userid' => $rest["userid"],
            "fullname" => $rest["dfullname"],
            'email' => $rest["demail"],
            'phone' => $rest["dphone"]
        ];

        //TODO: GENERATE ACCESS TOKEN (valid for 1 hour)
        $newAccessToken = $jwtHandler->generateToken($grant,  time() + (60 * 60));

        Response::send(200, [
            'access_token' => $newAccessToken
        ]);
    } catch (Exception $e) {
        Response::send(401, ['error' => 'Invalid refresh token']);
    }
}
