<?php


class Model
{

    private $connection; // Instance of the Connection class
    private $pdo;
    private $query;
    private $helper;
    private $jwt;
    private $sms;
    public function __construct(Database $connection)
    {
        $this->connection = $connection;
        $this->pdo = $this->connection->getPDO();
        $this->query = new QueryBuilder($this->connection->getPDO());
        $this->helper = new Helper($this->connection->getPDO());
        $this->jwt = new JWTHandler();
        $this->sms = new SmsSender();
    }


    // User Login
    public function login($email, $password)
    {

        $user = $this->query->read('dcustomers')
            ->where(['demail' => $email])
            ->orWhere(['dphone' => $email])
            ->get('*', false);

        if ($user) {
            $hashedPassword = CommonFunctions::hashPassword($password);
            $fullname = $user["dfirstname"] . ' ' . $user["dlastname"];
            include_once dirname(__DIR__) . "/userinfo.php";

            $token = $this->jwt->generateToken([
                'userid' => $user["userid"],
                "fullname" => $fullname,
                'email' => $user["demail"],
                'phone' => $user["dphone"]
            ]);

            if (hash_equals($hashedPassword, $user["dpassword"])) {
                //TODO: CHECK THE STATUS OF THE ACCOUNT
                if ($user["verificationStatus"] == 'pending') {
                    $name = $user["dfirstname"];
                    $userid = $user["userid"];
                    $phone = $user["dphone"];
                    $pin = rand(1234, 5678);
                    //TODO: SEND PIN TO EMAIL & SMS
                    $subject = "Verification | Xrider Services";
                    $msg = "
                    <b>Dear $name,</b>  welcome to Xrider Services.
                    <P>Use this code <b>$pin</b> to verify your account.</P>                    
                    ";
                    $msg = "Use this $pin to activate your account";
                    // CommonFunctions::sendMessage($phone, $textMessage);
                    // $this->sms->sendSms($phone, $msg);
                    // CommonFunctions::sendMail($msg, $email, $subject);

                    $template = dirname(dirname(__DIR__)) . "/emailController/mailTemplate.php";
                    EmailSender::sendEmail($email, $name, $subject, $template, $msg);
                    $this->helper->update("dcustomers", ["dpin" => $pin], ["userid" => $userid]);

                    $data =  Response::send(200, [
                        'accessCode' => 'VERIFICATION',
                        "data" => $result,
                        'token' => $token,
                    ]);
                } elseif ($user["dstatus"] == 'banned') {
                    $data =  Response::send(400, [
                        'ACCESS_CODE' => 'DENIED',
                        'token' => '',
                        'msg' => "Your account has been banned, you cannot login to your account."
                    ]);
                } else {
                    $data =  Response::send(200,  [
                        "accessCode" => 'GRANTED',
                        "data" => $result,
                        'token' => $token,
                    ]);
                }
            } else {
                $data =  Response::send(400,  [
                    'ACCESS_CODE' => 'DENIED',
                    'msg' => "Incorect password provided."
                ]);
            }
        } else {
            $data =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, we don't have the information you provided."
            ]);
        }

        return $data; // Login failed
    }

    //? new registration
    public function createNewUser(string $email, string $phone, array $data)
    {


        $userid = $data['userid'];
        $name = $data['dfirstname'];
        $pin = $data['dpin'];
        $fullname = $data["dfirstname"] . ' ' . $data["dlastname"];
        $userEmail =  $this->query->read('dcustomers')
            ->where(['demail' => $email])
            ->get('demail', false);

        if (empty($userEmail)) {

            $userPhone =  $this->query->read('dcustomers')
                ->where(['dphone' => $phone])
                ->get('dphone', false);
            if (empty($userPhone)) {
                $insertedId = null;
                if ($this->helper->create("dcustomers", $data, $insertedId)) {
                    $referralId = $insertedId . rand(12345, 67890);
                    $this->helper->update("dcustomers", ['referralId' => $referralId], ['userid' => $userid]);
                    $subject = "Verification | Xrider Services";
                    $msg = "
                      <b>Dear $name,</b>  welcome to Xrider Services.
                      <P>Use this code <b>$pin</b> to verify your account.</P>                    
                      ";

                    $textMessage = "Use this code $pin to verify your account";
                    $template = dirname(dirname(__DIR__)) . "/emailController/mailTemplate.php";
                    EmailSender::sendEmail($email, $name, $subject, $template, $msg);
                    // CommonFunctions::sendMail($msg, $email, $subject);

                    $token = $this->jwt->generateToken([
                        'userid' => $data["userid"],
                        "fullname" => $fullname,
                        'email' => $data["demail"],
                        'phone' => $data["dphone"]
                    ]);

                    $result =  Response::send(200, [
                        'token' => $token,
                        'data' => [
                            'accessCode' => 'GRANTED',
                            'userid' => $data["userid"],
                            'msg' => "Verify your account with the code sent to your email address or phone number."
                        ],
                    ]);
                } else {
                    $result =  Response::send(400, [
                        'accessCode' => 'DENIED',
                        'msg' => "Sorry, Something went wrong."
                    ]);
                }
            } else {
                $result =  Response::send(400, [
                    'accessCode' => 'DENIED',
                    'msg' => "Sorry, Phone number already taken."
                ]);
            }
        } else {
            $result =  Response::send(400, [
                'accessCode' => 'DENIED',
                'user' => null,
                'msg' => "Sorry, Email address already taken."
            ]);
        }


        return $result;
    }

    //  TODO:VERIFY ACCOUNT
    public function resendToken($userid)
    {
        $user = $this->query->read('dcustomers')
            ->where(['userid' => $userid])
            ->get('dfirstname, demail, userid', false);

        if (!empty($user)) {

            $name = $user["dfirstname"];
            $email = $user["demail"];
            $userid = $user["userid"];
            $pin = rand(1234, 5678);
            //TODO: SEND PIN TO EMAIL & SMS
            $subject = "Verification | Xrider Services";
            $msg = "
            <b>Dear $name,</b>  welcome to Xrider Services.
            <P>Use this code <b>$pin</b> to verify your account.</P>                    
            ";

            $template = dirname(dirname(__DIR__)) . "/emailController/mailTemplate.php";
            EmailSender::sendEmail($email, $name, $subject, $template, $msg);

            $this->helper->update("dcustomers", ["dpin" => $pin], ["userid" => $userid]);
            $data =  Response::send(200,  [
                'ACCESS_CODE' => 'Success',
                'msg' => "Token has been sent to your account"
            ]);
        } else {
            $data =  Response::send(400,  [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, invalid code provided."
            ]);
        }

        return $data;
    }


    //  TODO:VERIFY ACCOUNT
    public function verifyAccount($userid, $pin)
    {
        $user = $this->query->read('dcustomers')
            ->where(['userid' => $userid, "dpin" => $pin])
            ->get('*', false);

        if ($user) {
            $this->helper->update(
                "dcustomers",
                ["verificationStatus" => 'verified', "dstatus" => 'active'],
                ["userid" => $userid]
            );
            $user = $this->helper->getSingleRecord('dcustomers', "WHERE userid='$userid'");
            $fullname = $user["dfirstname"] . ' ' . $user["dlastname"];
            $token = $this->jwt->generateToken([
                'userid' => $user["userid"],
                "fullname" => $fullname,
                'email' => $user["demail"],
                'phone' => $user["dphone"]
            ]);
            include_once dirname(__DIR__) . "/userinfo.php";
            $result =  Response::send(200, [
                'ACCESS_CODE' => 'GRANTED',
                'data' => $result,
                'token' => $token,
                'msg' => "Verified! continue"
            ]);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, invalid code provided."
            ]);
        }

        return $result;
    }

    public function forgotPassword(string $email)
    {
        //TODO: Check if email exist
        $userEmail =  $this->query->read('dcustomers')
            ->where(['demail' => $email])
            ->get('demail, dfirstname, dphone, dstatus', false);

        if (!empty($userEmail)) {
            //TODO: Send security code
            $rand = rand(1234, 5678);
            $subject = "Reset Password";
            $name = $userEmail['dfirstname'];
            $phone = $userEmail['dphone'];
            $msg = "
            <b>Dear $name,</b> <br>
            <p>Use this code <b>$rand</b> to reset your password</p>
            <p>Kindly ignore this if the request is not from you</p>
            ";
            $textMessage = "Use this code $rand to reset your password";
            CommonFunctions::sendMessage($phone, $textMessage);
            // CommonFunctions::sendMail($msg, $email, $subject);

            $template = dirname(dirname(__DIR__)) . "/emailController/mailTemplate.php";
            EmailSender::sendEmail($email, $name, $subject, $template, $msg);

            $this->helper->update('dcustomers', ["dpin" => $rand], ["demail" => $email]);
            $result =  Response::send(200, [
                'ACCESS_CODE' => 'GRANTED',
                'msg' => "Reset code has been sent to your email."
            ]);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'user' => null,
                'msg' => "Sorry, Email address does not exist."
            ]);
        }

        return $result;
    }


    public function resetPassword(string $email, string $token, string $pass)
    {
        //TODO: Check if email exist
        $userEmail =  $this->query->read('dcustomers')
            ->where(['demail' => $email, 'dpin' => $token])
            ->get('demail, dfirstname', false);

        if (!empty($userEmail)) {
            $pass = CommonFunctions::hashPassword($pass);
            $this->helper->update('dcustomers', ["dpassword" => $pass], ["demail" => $email]);
            $result = Response::send(200, [
                'ACCESS_CODE' => 'GRANTED',
                'msg' => "Reset successfully."
            ]);
        } else {
            $result = Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'user' => null,
                'msg' => "Sorry, invalid token submitted."
            ]);
        }

        return $result;
    }


    public function changePassword($userid, $oldPass, $newPass)
    {

        $user = $this->query->read('dcustomers')
            ->where(['userid' => $userid, "dpassword" => CommonFunctions::hashPassword($oldPass)])
            ->get('dpassword', false);

        if (!empty($user)) {

            if ($this->helper->update("dcustomers", ["dpassword" => CommonFunctions::hashPassword($newPass)], ["userid" => $userid])) {
                $result =  Response::send(200, [
                    'ACCESS_CODE' => 'ACCESS',
                    'msg' => "updated successfully."
                ]);
            }
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'user' => null,
                'msg' => "Sorry, Incorrect password."
            ]);
        }

        return $result;
    }



    public function updatePersonalDetails(array $data, array $clause)
    {

        //TODO: update details
        if ($this->helper->update("dcustomers", $data, $clause)) {
            $userid = $clause['userid'];
            $user = $this->helper->getSingleRecord('dcustomers', "WHERE userid = '$userid'");

            if (!empty($user)) {
                $result = [
                    "userid" => $user["userid"],
                    "firstname" => $user["dfirstname"],
                    "lastname" => $user["dlastname"],
                    "fullname" => $user["dfullname"],
                    "phone" => $user["dphone"],
                    "email" => $user["demail"],
                    "computerId" => $user["computerId"],
                    "natureEmployed" => $user["natureEmployed"],
                    "yearEmployed" => $user["yearEmployed"],
                    "department" => $user["ddepartment"],
                    "designation" => $user["ddesignation"],
                    "residentAddress" => $user["residentAddress"],
                    "paymentSlip" => $user["paymentSlip"],
                    "passport" => $user["dpassport"],
                    "nextOfKinName" => $user["nextOfKinName"],
                    "nextOfKinGender" => $user["nextOfKinGender"],
                    "nextOfKinRelationship" => $user["nextOfKinRelationship"],
                    "nextOfKinPhone" => $user["nextOfKinPhone"],
                    "accountName" => $user["accountName"],
                    "accountNumber" => $user["accountNumber"],
                    "bankName" => $user["bankName"],
                    "accountStatus" => $user["account_status"],
                    "status" => $user["dstatus"],
                ];

                $subject = "Personal detail submitted";
                $name = $user["dfirstname"];
                $email = 'youngelefiku@gmail.com';
                $msg = "
                <b>Dear Xrider Services Loan Service,</b>
                <P><b>$name</b> has submitted personal details, 
                kindly login to the admin panel to approve or cancel the details.</P>                    
                ";

                // $textMessage = "$name has requested for a loan of $amount";
                // CommonFunctions::sendMessage("", $textMessage);


                $template = __DIR__ . "/emailController/mailTemplate.php";
                EmailSender::sendEmail($email, $name, $subject, $template, $msg);
            } else {
                http_response_code(400);
                $result = [
                    'ACCESS_CODE' => 'DENIED',
                    'msg' => "Sorry, we\'re unable to submit your request."
                ];
            }
        } else {
            http_response_code(400);
            $result = [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, something went wrong."
            ];
        }



        return $result;
    }

    public function getData()
    {
        $row =  $this->query->read('dlist')
            ->get('*', false);
        if (!empty($row)) {
            $result =  Response::send(200, [
                "about" => html_entity_decode($row["dabout"]),
                "terms" => html_entity_decode(html_entity_decode($row["dterms"])),
                "privacy" => html_entity_decode($row["dprivacy"]),
                "works" => html_entity_decode($row["dworks"])
            ]);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, we\'re unable to fetch data."
            ]);
        }

        return $result;
    }
    public function fetchUser(array $clause)
    {
        $user =  $this->query->read('dcustomers')
            ->where($clause)
            ->get('*', false);
        if (!empty($user)) {
            $fullname = $user["dfirstname"] . ' ' . $user["dlastname"];
            include_once dirname(__DIR__) . "/userinfo.php";
            $result =   Response::send(200,  [
                "accessCode" => 'GRANTED',
                "data" => $result,
            ]);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, we\'re unable to fetch data."
            ]);
        }

        return $result;
    }


    public function category()
    {
        $result = [];
        $rows =  $this->query->read('dcategory')
            ->get();
        if (!empty($rows)) {

            foreach ($rows as $key => $row) {
                $result[] = [
                    'id' => $key + 1,
                    'category' => $row['dcategory'],
                    'perKm' => $row['perKm'],
                ];
            }


            $result =  Response::send(200, $result);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, we\'re unable to fetch data."
            ]);
        }

        return $result;
    }

    public function processBooking(string $senderName, string $senderEmail, string $trackingCode, array $data)
    {
        if ($this->helper->create("dbookings", $data)) {
            $subject = "Booking | Confirmation";
            $msg = "
              <b>Dear $senderName,</b> <br>
              <b>Booking ID: $trackingCode,</b> <br>
              <P>Your booking has been received, our rider will contact you as soon as possible to pickup your item(s) for delivery.</P>         
              <p>Thank you for using us</p>
              <p>Xrider Service.</p>           
              ";

            $template = dirname(dirname(__DIR__)) . "/emailController/mailTemplate.php";
            EmailSender::sendEmail($senderEmail, $senderName, $subject, $template, $msg);
            $result =  Response::send(200, [
                "ACCESS_CODE" => "GRANTED",
                "msg" => "Booking created successfully!"
            ]);
        } else {
            $result =  Response::send(400, [
                'ACCESS_CODE' => 'DENIED',
                'msg' => "Sorry, we\'re unable to process data."
            ]);
        }

        return $result;
    }


    public function fetchBookings(array $clause)
    {
        $result = [];
        $rows =  $this->query->read('dbookings')
            ->where($clause)
            ->orderBy('id DESC')
            ->get();
        if (!empty($rows)) {

            foreach ($rows as $row) {
                $result[] = [
                    'bid' => $row['bid'],
                    'category' => $row['dcategory'],
                    'trackingCode' => $row['trackingCode'],
                    'senderName' => $row['senderName'],
                    'senderPhone' => $row['senderPhone'],
                    'receiverName' => $row['receiverName'],
                    'receiverPhone' => $row['receiverPhone'],
                    'deliveryType' => $row['deliveryType'],
                    'pickupAddress' => $row['pickupAddress'],
                    'pickupLat' => $row['pickupLat'],
                    'pickupLong' => $row['pickupLong'],
                    'dropoffAddress' => $row['dropoffAddress'],
                    'dropofflat' => $row['dropofflat'],
                    'dropoffLong' => $row['dropoffLong'],
                    'pickupDate' => $row['pickupDate'],
                    'ddistance' => $row['ddistance'],
                    'riderName' => $row['riderName'],
                    'riderPhone' => $row['riderPhone'],
                    'dcost' => $row['dcost'],
                    'paymentStatus' => $row['paymentStatus'],
                    'dstatus' => $row['dstatus'],
                    'ddate' => $row['ddate'],
                ];
            }


            $result =  Response::send(200, $result);
        } else {
            $result =  Response::send(200, []);
        }

        return $result;
    }
}

//`dnegotiate`='[value-26]',`negotiatePrice`='[value-27]',`negotiateStatus`='[value-28]',`searchDate`='[value-31]' WHERE 1
