$(document).ready(function () {

    $(document).on("click", "#unban", function () {
        var cid = $(this).attr("user");
        magicFunction('Unban this account?', 'ajax-success', 'UnBan', cid, '', 'Confirmed');
    })

    $(document).on("click", "#ban", function () {
        var cid = $(this).attr("user");
        magicFunction('Ban this account?', 'Ban', cid, '', 'Confirmed!', true);
    })


    $(document).on("click", "#csvBtn", function () {
        var status = $(this).attr('data-state');
        var fileName = $(this).attr('data-fileName');
        $("#csvBtn").html("Please wait...")
        $.ajax({
            url: 'export',
            method: "POST",
            data: { Message: status, fileName: fileName },
            xhrFields: {
                responseType: 'blob' // Expect a binary response
            },
            success: function (blob) {
                // Create a download link
                const url = window.URL.createObjectURL(blob);
                const downloadLink = document.createElement("a");
                downloadLink.href = url;
                downloadLink.download = fileName + ".csv";
                document.body.appendChild(downloadLink);
                downloadLink.click();
                document.body.removeChild(downloadLink);
                window.URL.revokeObjectURL(url);
                $("#csvBtn").html("Export to csv")
            },
            error: function () {
                alert("An error occurred while exporting the table.");
                $("#csvBtn").html("Export to csv")
            }
        })

    })


    //? ************* User alertify function *******************
    $(document).on("click", "#appRequest", function () {
        var dataString = $(this).attr('data-request');
        var requestData = JSON.parse(dataString);
        var message, response, retunLink = '', istrue;
        message = requestData.message;
        response = requestData.response;
        retunLink = requestData.retunLink;
        istrue = requestData.istrue;
        // Store the original button text
        // var originalText = $(this).html();
        // $(this).html('Please wait...');
        // console.log(requestData)
        // appRequest(message, requestData, response, retunLink, istrue);

        // Store the original button text
        var originalText = $(this).html();
        $(this).html('Please wait...');

        // Call appRequest and reset button text after completion
        appRequest(message, requestData, response, retunLink, istrue).then(() => {
            $(this).html(originalText); // Return the button to its original state
        }).catch(() => {
            $(this).html(originalText); // Reset button text even if there's an error
        });
    })

    //?Send message
    $(document).on("click", "#sendEmail", function () {
        var dataString = $(this).attr('data-request');
        var requestData = JSON.parse(dataString);
        var message, response;
        message = requestData.message;
        response = requestData.response;
        console.log(requestData)
        appSendMail(message, requestData, response);
    })


    //? ********************************





    $(document).on("click", "#hudoDelete", function () {
        var id = $(this).attr("user");
        var state = $(this).attr("state");
        const dataUser = {
            id: id,
            state: state
        }
        magicFunction('Delete this?', 'hudoDelete', dataUser, '', 'Deleted!', true);
    })




})



//? ******************* Alertify function **************************************************


function appRequest(message, requestData, response, retunLink, reLoad = false) {
    return new Promise((resolve, reject) => {
        alertify.confirm('Alert', message, () => {

            $.ajax({
                url: 'ajax-success',
                method: "POST",
                data: { Message: 'appRequest', id: requestData },
                success: function (data) {
                    // Set the redirect based on reLoad flag
                    setTimeout(function () {
                        if (reLoad) {
                            window.location.reload();
                        } else {
                            window.location.assign(retunLink);
                        }
                    }, 2000);
                    resolve(); // Resolve the promise on success
                },
                error: function () {
                    alertify.error('Something went wrong with ajax!');
                    reject(); // Reject the promise on error
                }
            }).done(function () {
                alertify.success(response);
            });

        }, () => { reject(); }).set({ labels: { ok: 'Yes', cancel: 'No' } });
    });
}


//?SEND MESSAGE
function appSendMail(message, requestData, response) {

    alertify.confirm('Alert', message, () => {

        $.ajax({
            url: 'ajax-success',
            method: "POST",
            data: { Message: 'sendMessage', id: requestData },
            success: function (data) {

            }
        }).done(function () {
            alertify.success(response);
        }).fail(function () {
            alertify.error('Something went wrong with ajax!');
        });
    }, () => { }).set({ labels: { ok: 'Yes', cancel: 'No' } });

}

//? ************************************************


$(function () {
    // code...
    var currentValue = $('.update option:selected'),
        i = 1;
    currentValue.each(function () {
        var value = $(this).val();
        var gid = $(this).attr("pid");
        if (value != "") {
            fireDataForMe("category-search", "Subs", value, "#sub" + i++, gid);
        }
    });
});

function fireDataForMe(dataPost, dataValue, dataId) {
    $.ajax({
        url: 'ajax-success',
        method: "POST",
        data: { Message: dataPost, id: dataValue },
        success: function (data) {
            $(dataId).html(data);
        }
    });
}

function fireDataWithJson(dataPost, dataValue, dataId) {
    $.ajax({
        url: 'ajax-success',
        method: "POST",
        dataType: "json",
        data: { Message: dataPost, id: dataValue },
        success: function (data) {
            $(dataId).html(data.check);
        }
    });
}




function magicFunction(sweetTitle, dataTitle, dataId, retunLink, sweetSuccess, reLoad = false, textReturn = '') {
    Swal.fire({
        position: 'center',
        type: 'warning',
        title: sweetTitle,
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes!'
    }).then((result) => {
        if (result.value) {
            $.ajax({
                url: 'ajax-success',
                method: "POST",
                data: { Message: dataTitle, id: dataId },
                success: function () {
                    setInterval(function () {
                        if (reLoad) {
                            window.location.reload();
                        } else {
                            window.location.assign(retunLink);
                        }
                    }, 2000);
                }
            }).done(function () {
                Swal.fire({
                    type: 'success',
                    text: textReturn,
                    title: sweetSuccess
                });
            }).fail(function () {
                Swal.fire('Oops...', 'Something went wrong with ajax !', 'error');
            });
        }
    });

}



//toast
function fireForMe(dataResult, dataType) {
    $.toast({
        heading: 'Notification',
        text: dataResult,
        position: 'bottom-right',
        loaderBg: '#ff6849',
        icon: dataType,
        hideAfter: 3500,
        stack: 6
    })
}


//Copy to clipboard
function copyToClipboard(element) {
    var $temp = $("<input>");
    $("body").append($temp);
    $temp.val($(element).html()).select();
    document.execCommand("copy");
    $temp.remove();
    $temp.remove();
}
// }$temp.remove();
// }
// }



function exportTableToCSV(filename) {
    let csv = [];

    // Loop through each row in the table
    $("#csv tr").each(function () {
        let rowData = [];

        // Loop through each cell in the row
        $(this).find("th, td").each(function () {
            rowData.push($(this).text().trim());
        });

        csv.push(rowData.join(",")); // Join cells with a comma to form a row
    });

    // Create a Blob from the CSV data
    const csvFile = new Blob([csv.join("\n")], { type: "text/csv" });

    // Create a download link
    const downloadLink = document.createElement("a");
    downloadLink.href = URL.createObjectURL(csvFile);
    downloadLink.download = filename;

    // Trigger the download
    downloadLink.click();
}
