<?php

require 'clean.php';
// Set headers to download the file
header('Content-Type: text/csv');

$fileName = clean($_POST['fileName']);
header('Content-Disposition: attachment; filename="' . $fileName . '.csv"');
// Open the output stream
$output = fopen('php://output', 'w');

$id = clean($_POST['Message']);
// Fetch data from the database based on the given condition and order by date
$sql = runQuery("SELECT dl.dfullname, dl.computerId, dl.userid, dr.amountApply, dr.spreadPeriod, dr.amountAvailable, dr.drate, dr.totalBalance, dr.amountDeducted, dr.ddate, dr.dstatus, dr.loanId, dr.rid, dr.processingFee, dr.clearingFee FROM drequest dr INNER JOIN dlogin dl ON dr.userid = dl.userid WHERE dr.dstatus = '$id' ORDER BY dr.ddate DESC ");

if (isset($_POST['Message']) && $_POST['Message'] == 'pending') {

    // Add the table headers
    fputcsv($output, ['S/N', 'Date', 'Loan ID', 'Computer ID', 'Fullname', 'Amount Applied', 'Duration', 'Rate (6%)', 'Monthly Deduction', 'Total Interest']); // Adjust headers as per your table columns

    $sn = 1; // Serial number counter
    // Initialize totals for summary
    $totalAmountApplied = 0;
    $totalMonthlyPayment = 0;
    $totalInterestRate = 0;

    while ($row = fetchAssoc($sql)) {
        // Calculate any dynamic fields if needed
        $monthlyDeduction = 'NGN ' . number_format($row['amountDeducted'], 2);
        $totalInterest = 'NGN ' . number_format(($row['amountApply'] * 0.06) * removeMonths($row['spreadPeriod']), 2);

        $totalAmountApplied += $row['amountApply'];
        $totalMonthlyPayment += $row['amountAvailable'];
        $totalInterestRate += ($row['amountApply'] * 0.06) * removeMonths($row['spreadPeriod']);

        // Create a row array for CSV output
        $csvRow = [
            $sn++, // Serial number
            formatNormalDate($row['ddate']), // Date
            $row['loanId'], // Loan ID
            $row['computerId'], // computerId
            $row['dfullname'], // Fullname
            'NGN ' . number_format($row['amountApply'], 2), // Amount Applied
            $row['spreadPeriod'], // Duration
            $row['drate'], // Rate (6%)
            $monthlyDeduction, // Monthly Deduction
            $totalInterest // Total Interest
        ];
        // Write the row to CSV
        fputcsv($output, $csvRow);
    }

    // Add a summary row with totals
    $summaryRow = [
        '',
        '',
        '',
        '',
        '',
        'NGN ' . number_format($totalAmountApplied, 2), // Total Amount Applied
        '',
        '',
        'NGN ' . number_format($totalMonthlyPayment, 2), // Total Monthly Deduction
        'NGN ' . number_format($totalInterestRate, 2) // Total Interest
    ];

    // Write the summary row to CSV
    fputcsv($output, $summaryRow);
}

if (isset($_POST['Message']) && ($_POST['Message'] == 'cleared' || $_POST['Message'] == 'active' || $_POST['Message'] == 'cancelled')) {
    // Add the table headers
    fputcsv($output, ['S/N', 'Date', 'Loan ID', 'Computer ID', 'Fullname', 'Amount Applied', 'Monthly Principal', 'Monthly Interest',  'Rate (6%)', 'Duration', 'Total Interest Paid', 'Payable', 'Monthly Deduction', 'Balance', 'Processing Fee']); // Adjust headers as per your table columns
    $sn = 1;
    $amountApplied = $monthlyPayment = $monthlyPrin =  $totalMonthlyInt = $totalPayable = $totalInt = $totalBalance = $processingFee = 0;



    while ($row = fetchAssoc($sql)) {
        if (!empty($row['clearingFee'])) {
            $totalMonthlyInt += $row['clearingFee'];
            $monthlyPrin += $row['amountApply'];

            // Create a row array for CSV output
            $csvRow = [
                $sn++, // Serial number
                formatNormalDate($row['ddate']), // Date
                $row['loanId'], // Loan ID
                $row['computerId'], // computerId
                $row['dfullname'], // Fullname
                '0.00',
                'NGN ' . number_format($row['amountApply'], 2), // Amount Applied
                $row['clearingFee'], // Monthly Interest
                '0', // Rate (6%)
                '0', // Duration
                '0.00', // Total Interest
                '0.00', // Monthly Deduction
                '0.00', // Monthly Deduction
                '0.00', // Balance
                '0.00', // processingFee
            ];
            // Write the row to CSV
            fputcsv($output, $csvRow);
            
        } else {
            // Calculate any dynamic fields if needed
            $monthlyPrincipal = 'NGN ' . number_format($row['amountDeducted'] - ($row['amountApply'] * 0.06), 2);
            $monthlyInterest = 'NGN ' . number_format(($row['amountApply'] * 0.06), 2);
            $totalInterest = 'NGN ' . number_format(($row['amountApply'] * 0.06) * removeMonths($row['spreadPeriod']), 2);
            $Payable = 'NGN ' . number_format($row['amountDeducted'] * removeMonths($row['spreadPeriod']), 2);
            $monthlyDeduction = 'NGN ' . number_format($row['amountDeducted'], 2);
            $balance = 'NGN ' . number_format($row['totalBalance'], 2);

            $amountApplied += $row['amountApply'];
            $monthlyPayment += $row['amountAvailable'];
            $totalMonthlyInt += ($row['amountApply'] * 0.06);
            $monthlyPrin += $row['amountDeducted'] - ($row['amountApply'] * 0.06);
            $totalBalance += $row['totalBalance'];
            $processingFee += $row['processingFee'];
            $totalPayable += $row['amountDeducted'] * removeMonths($row['spreadPeriod']);

            $totalInt += ($row['amountApply'] * 0.06) * removeMonths($row['spreadPeriod']);

            // Create a row array for CSV output
            $csvRow = [
                $sn++, // Serial number
                formatNormalDate($row['ddate']), // Date
                $row['loanId'], // Loan ID
                $row['computerId'], // computerId
                $row['dfullname'], // Fullname
                'NGN ' . number_format($row['amountApply'], 2), // Amount Applied
                $monthlyPrincipal, // Month 
                $monthlyInterest, // Monthly Interest
                $row['drate'], // Rate (6%)
                $row['spreadPeriod'], // Duration
                $totalInterest, // Total Interest
                $Payable, // Monthly Deduction
                $monthlyDeduction, // Monthly Deduction
                $balance, // Balance
                $row['processingFee'], // processingFee
            ];
            // Write the row to CSV
            fputcsv($output, $csvRow);
        }
    }

    // Add a summary row with totals

    $summaryRow = [
        '',
        '',
        '',
        '',
        '',
        'NGN ' . number_format($amountApplied, 2),
        'NGN ' . number_format($monthlyPrin, 2),
        'NGN ' . number_format($totalMonthlyInt, 2),
        '',
        '',
        'NGN ' . number_format($totalInt, 2),
        'NGN ' . number_format($totalPayable, 2),
        'NGN ' . number_format($monthlyPayment, 2),
        'NGN ' . number_format($totalBalance, 2),
        'NGN ' . number_format($processingFee, 2),
    ];
    // Write the summary row to CSV
    fputcsv($output, $summaryRow);
}


// Close the output stream
fclose($output);
exit;
