<?php

class Model
{

    private $connection; // Instance of the Connection class
    private $pdo;
    private $unique;
    private $uniqueOrderID;
    private $date;
    private $helper;
    private $query;

    public function __construct(Connection $connection)
    {
        $this->connection = $connection;
        $this->pdo = $this->connection->getPDO();
        $this->helper = new Helper($this->connection->getPDO());
        $this->unique = CommonFunctions::generateUniqueID();
        $this->uniqueOrderID = CommonFunctions::generateOrderID();
        $this->date = CommonFunctions::getDateTime(1);
        $this->query = new QueryBuilder($this->connection->getPDO());
    }


    // User Login
    public function login($email, $password)
    {
        $user = $this->query->read('dadmin')
            ->where(['demailAddress' => $email])
            ->get('*', false);

        $pass = hash("SHA256", $password);
        if ($user) {
            if (hash_equals($pass, $user['dpassword'])) {
                session_start();
                $_SESSION['admin'] = true;
                $_SESSION['adminId'] = $user['adminid'];
                $_SESSION['adminEmail'] = $email;
                return true;
            } else {
                return false;
            }
        }

        return false;
    }

 


    public function changePassword($userid, $oldPass, $newPass)
    {
        // Check if the old password matches the one in the database
        $stmt = $this->pdo->prepare("SELECT dpass FROM dlogin WHERE userid = :userid");
        $stmt->bindParam(':userid', $userid);
        $stmt->execute();
        $user = $stmt->fetch();

        if ($user) {
            // Verify the old password
            $storedHashedPass = $user['dpass'];
            if (md5($oldPass) === $storedHashedPass) {
                $hashedNewPass = md5($newPass);

                $stmt = $this->pdo->prepare("UPDATE dlogin SET dpass = :newPass WHERE userid = :userid");
                $stmt->bindParam(':newPass', $hashedNewPass);
                $stmt->bindParam(':userid', $userid);

                if ($stmt->execute()) {
                    // Password changed successfully
                    return true;
                }
            } else {
                return "OLD_PASSWORD_NOT_FOUND";
                exit();
            }
        }
        // Old password doesn't match or update failed
        return false;
    }

    public function forgetPassword($email)
    {
        // Check if the old password matches the one in the database
        $stmt = $this->pdo->prepare("SELECT * FROM dlogin WHERE demail = :email");
        $stmt->bindParam(':email', $email);
        $stmt->execute();
        $user = $stmt->fetch();

        if ($user) {
            $pin = rand(1234, 5678);
            $name = $user['dfname'];
            $userid = $user['userid'];
            $phone = $user['dphone'];
            $_SESSION['phone'] = $phone;
            //send mail
            $subject = "Reset Password | Angel 11:11 Mart";
            $msg = "
            <b>Dear $name,</b>  welcome to Angel 11:11 Mart.
            <P>Use this code <b>$pin</b> to reset your password.</P>                     
            ";

            $otpMessage = "Use this code $pin to reset your password";

            CommonFunctions::sendMail($msg, $email, $subject);


            $stmt = $this->pdo->prepare("UPDATE dlogin SET dpin = :pin WHERE userid = :userid");
            $stmt->bindParam(':pin', $pin);
            $stmt->bindParam(':userid', $userid);

            if ($stmt->execute()) {
                return true;
            }
        } else {
            return false;
        }
    }
}
