<?php
require 'clean.php';

require './auth.php';
if ($user['dlevel'] != 'Administrator') {

    if (!in_array('User', $state)) {
        $_SESSION['msg'] = 'Fail! Access denied!';
        header('Location:dashboard');
    }
}


?>
<!DOCTYPE html>
<html lang="en">


<?php include 'style.php'; ?>

<body class="skin-default fixed-layout">


    <div id="main-wrapper">
        <!-- ============================================================== -->
        <!-- Topbar header - style you can find in pages.scss -->
        <!-- ============================================================== -->
        <?php include 'header.php'; ?>

        <!-- ============================================================== -->
        <!-- End Topbar header -->
        <!-- ============================================================== -->
        <!-- ============================================================== -->
        <!-- Left Sidebar - style you can find in sidebar.scss  -->
        <!-- ============================================================== -->
        <?php include 'aside-left.php'; ?>

        <!-- ============================================================== -->
        <!-- End Left Sidebar - style you can find in sidebar.scss  -->
        <!-- ============================================================== -->
        <!-- ============================================================== -->
        <!-- Page wrapper  -->
        <!-- ============================================================== -->
        <div class="page-wrapper">
            <!-- ============================================================== -->
            <!-- Container fluid  -->
            <!-- ============================================================== -->
            <div class="container-fluid">
                <!-- ============================================================== -->
                <!-- Bread crumb and right sidebar toggle -->
                <!-- ============================================================== -->
                <div class="row page-titles">
                    <div class="col-md-5 align-self-center">
                        <h4 class="text-themecolor">Dashboard </h4>
                    </div>
                    <div class="col-md-7 align-self-center text-right">
                        <div class="d-flex justify-content-end align-items-center">
                            <ol class="breadcrumb">
                                <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                                <li class="breadcrumb-item active">Repayment History </li>
                            </ol>
                        </div>
                    </div>
                </div>
                <?php
                $id = clean($_GET['key']);
                $loanid = clean($_GET['loanid']);
                $sql = runQuery("SELECT * FROM `dlogin` WHERE userid='$id' ");

                if (numRows($sql) > 0) {
                    $row = fetchAssoc($sql);
                    $img = empty($row['dpassport']) ? "./user.png" : SITELINK . '/' . $row['dpassport'];
                    $loan = runQuery("SELECT * FROM `drequest` WHERE loanId='$loanid' ");
                    $loans = fetchAssoc($loan);
                    $rid = $loans['rid'];
                    $name = $row['dfullname'];
                    $email = $row['demail'];

                ?>
                    <div class="row">


                        <div class="col-lg-12">
                            <div class="text-right mb-3">
                                <?php if ($loans['dstatus'] == 'active') { ?>
                                    <button type="button" data-toggle="modal" data-target="#login" class="btn btn-dark">Edit Loan</button>
                                    <button type="button" data-toggle="modal" data-target="#clear" class="btn btn-warning">Clear This Loan</button>
                                <?php } ?>
                            </div>
                            <div class="card">


                                <div class="card-body">
                                    <div class="printLoan">
                                        <center>
                                            <h3>Samogoza Loan Repayment Skills</h3>
                                        </center>


                                        <div class="row mt-5">
                                            <div class="col-md-4 mb-4">

                                                <div class="packer">
                                                    <div class="my-5 hidden">
                                                        <img src="./<?= LOGO ?>" style="max-width: 200px;" alt="">
                                                    </div>
                                                    <div class="ptwo">
                                                        <center>
                                                            <img src="<?php echo $img ?>" class="img-thumbnail" style="width: 180px !important;height: 180px !important;">
                                                        </center>
                                                    </div>
                                                </div>
                                            </div>

                                            <div class="col-md-8">

                                                <?php if (isset($_SESSION['msg'])) echo $_SESSION['msg']; ?>
                                                <div class="table-responsive ">
                                                    <table class="table table-hover no-wrap">

                                                        <tbody>

                                                            <tr>
                                                                <th>Fullname</th>

                                                                <td><?php echo ucfirst($row['dfullname']); ?></td>

                                                            </tr>

                                                            <tr>
                                                                <th>Phone</th>
                                                                <td><?php echo $row['dphone']; ?></td>
                                                            </tr>

                                                            <tr>
                                                                <th>Email</th>
                                                                <td><?php echo $row['demail']; ?></td>
                                                            </tr>
                                                            <tr>
                                                                <th>Computer ID</th>
                                                                <td><?= ($row['computerId']) ?></td>
                                                            </tr>
                                                            <?php if (!empty($loans['clearingFee'])) { ?>
                                                                <tr>
                                                                    <th>Clearing Fee</th>
                                                                    <td><?= formatNaira($loans['clearingFee']) ?></td>
                                                                </tr>
                                                            <?php } ?>


                                                        </tbody>
                                                    </table>



                                                </div>


                                            </div>


                                        </div>

                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="table-responsive">
                                                    <table class="table">


                                                        <thead>
                                                            <tr>
                                                                <th>Loan ID</th>

                                                                <th>Amount Applied</th>

                                                                <th>Total Repayment</th>
                                                                <th>Total Monthly Repayment</th>

                                                                <th>Total Loan Cleared</th>

                                                                <th>Total Outstanding Balance</th>
                                                                <th>Status</th>
                                                            </tr>

                                                        </thead>

                                                        <tbody>
                                                            <?php if (!empty($loans['clearingFee'])) { ?>
                                                                <tr>
                                                                    <td><?php echo $loanid; ?></td>
                                                                    <td><?= formatNaira($loans['amountApply']) ?></td>
                                                                    <td>0.00</td>
                                                                    <td>0.00</td>
                                                                    <td><?= formatNaira(ceil($loans['totalPayment'])) ?></td>
                                                                    <td><?= formatNaira($loans['totalBalance']) ?></td>
                                                                    <td><?= ucfirst($loans['dstatus']) ?></td>
                                                                </tr>
                                                            <?php } else { ?>
                                                                <tr>
                                                                    <td><?php echo $loanid; ?></td>
                                                                    <td><?= formatNaira($loans['amountApply']) ?></td>
                                                                    <td><?= formatNaira($loans['amountApply'] + ($loans['amountApply'] * 0.06) * removeMonths($loans['spreadPeriod'])) ?></td>
                                                                    <td><?= formatNaira(($loans['amountApply'] * 0.06) * removeMonths($loans['spreadPeriod'])) ?></td>
                                                                    <td><?= formatNaira(ceil($loans['totalPayment'])) ?></td>
                                                                    <td><?= formatNaira($loans['totalBalance']) ?></td>
                                                                    <td><?= ucfirst($loans['dstatus']) ?></td>
                                                                </tr>
                                                            <?php } ?>
                                                        </tbody>


                                                    </table>
                                                </div>
                                            </div>
                                            <?php $getRepayment = false;
                                            $c = $conn->query("SELECT * FROM `drepayment` WHERE requestId ='$rid' AND userid = '$id' AND dstatus != 'editted'");

                                            if ($c->num_rows > 0) { ?>
                                                <div class="col-md-12 mt-3">


                                                    <h3>Loan Repayment History</h3>
                                                    <div class="table-responsive ">
                                                        <table class="table table-hover no-wrap">
                                                            <thead>
                                                                <tr>
                                                                    <th>S/N</th>
                                                                    <th>Date</th>
                                                                    <th>Title</th>
                                                                    <th>Monthly Prin</th>
                                                                    <th>Interest (Monthly)</th>
                                                                    <th>Total Repayment</th>
                                                                    <th>Payment Status</th>
                                                                </tr>
                                                            </thead>
                                                            <tbody>
                                                                <?php

                                                                $totalPay =  $totalInterestPaid = $totalPendingInterest = $newRepayment = 0;
                                                                $getRepayment = true;
                                                                $num =  1;
                                                                $newCount = 0;
                                                                while ($rowx = $c->fetch_assoc()) :
                                                                    if ($rowx['dstatus'] == 'cleared') {
                                                                        $totalPay += $rowx['damount'];
                                                                        $interest = $loans['amountApply'] * 0.06;
                                                                        $totalInterestPaid += $interest;
                                                                    }

                                                                    if ($rowx['dstatus'] == 'pending') {
                                                                        $newRepayment += $rowx['damount'] - ($loans['amountApply'] * 0.06);
                                                                        $newCount++;
                                                                        $totalPendingInterest += $loans['amountApply'] * 0.06;
                                                                    }
                                                                ?>
                                                                    <tr>

                                                                        <td><?php echo $num++ ?></td>
                                                                        <td><?php echo formatDate($rowx['payDate']); ?></td>

                                                                        <td><?php echo $rowx['dtitle']; ?></td>
                                                                        <td><?= formatNaira($rowx['damount'] - ($loans['amountApply'] * 0.06)) ?></td>
                                                                        <td><?php echo formatNaira(($loans['amountApply'] * 0.06)); ?></td>
                                                                        <td><?php echo formatNaira($rowx['damount']); ?></td>
                                                                        <td><?php echo ucfirst($rowx['dstatus']); ?></td>


                                                                    </tr>
                                                                <?php endwhile; ?>




                                                            </tbody>
                                                        </table>

                                                        <?php if ($getRepayment) { ?>

                                                            <center class="d-none">
                                                                <img src="./<?= LOGO ?>" style="max-width: 200px;" alt="">
                                                            </center>
                                                            <div class="text-right ">

                                                                <a href="javascript:void(0)" id="loan" class="btn btn-dark no-print">Print Loan History</a>
                                                            </div>
                                                        <?php } ?>


                                                    </div>


                                                </div>
                                            <?php } ?>
                                        </div>
                                    </div>


                                </div>
                            </div>


                        </div>
                    </div>
                <?php } ?>
            </div>

        </div>
        <!-- ============================================================== -->
        <!-- End Container fluid  -->
        <!-- ============================================================== -->
    </div>



    <!-- ============================================================== -->
    <!-- End Page wrapper  279,000.00 -->
    <!-- ============================================================== -->
    <?php include 'footer.php'; ?>

    </div>
    <!-- ============================================================== -->
    <!-- End Wrapper -->
    <!-- ============================================================== -->

    <?php include 'script.php'; ?>

    <div class="modal fade" id="login" role="dialog" aria-labelledby="addressModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <form action="controller" method="post" enctype="multipart/form-data">
                    <div class="modal-header">
                        <h4 class="modal-title" id="addressModalLabel">Edit Loan </h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div><!-- End .modal-header -->
                    <div class="modal-body">


                        <div class="row ">
                            <div class="col-md-12">
                                <label for="accName">Fullname</label>
                                <input type="text" class="form-control" readonly value="<?= $name ?>">
                            </div>
                            <div class="col-md-12">
                                <label for="accNumber">Email Address</label>
                                <input type="text" readonly class="form-control" value="<?= $email ?>">
                            </div>
                            <div class="col-md-12">
                                <label for="bank">Current Balance</label>
                                <input type="number" required name="amount" value="<?= ceil($newRepayment) ?>" class="form-control" placeholder="Current Balance">
                            </div>
                            <div class="mb-3 col-md-12">
                                <label for="year">Duration</label>
                                <select name="duration" required id="spread" class="form-control">
                                    <option value="">Select duration</option>
                                    <?php for ($i = 1; $i < 24; $i++) { ?>
                                        <option value="<?= $i ?>"><?= $i ?> Month<?= $i != 1 ? 's' : '' ?></option>
                                    <?php } ?>
                                </select>
                            </div>

                        </div>


                        <input type="hidden" name="link" value="view?loanid=<?php echo $loanid ?>&key=<?= $id ?>">
                        <input type="hidden" name="userid" value="<?php echo $id ?>">
                        <input type="hidden" name="name" value="<?php echo $name ?>">
                        <input type="hidden" name="email" value="<?php echo $email ?>">
                        <input type="hidden" name="loadId" value="<?php echo $rid ?>">

                        <input type="hidden" name="intialDuration" value="<?php echo $loans['spreadPeriod'] ?>">
                        <input type="hidden" name="currentDuration" value="<?php echo $newCount ?>">
                        <input type="hidden" name="totalLoanPaid" value="<?php echo $loans['totalPayment'] ?>">
                        <input type="hidden" name="amountApply" value="<?php echo $loans['amountApply'] ?>">



                    </div><!-- End .modal-body -->
                    <div class="modal-footer">
                        <button type="button" class="btn btn-link btn-sm" data-dismiss="modal">Close</button>

                        <button type="submit" name="editLoan" value="Create" class="btn btn-primary btn-sm">Submit</button>
                    </div><!-- End .modal-footer -->
                </form>
            </div><!-- End .modal-content -->
        </div><!-- End .modal-dialog -->
    </div>

    <div class="modal fade" id="clear" role="dialog" aria-labelledby="addressModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <form action="controller" method="post" enctype="multipart/form-data">
                    <div class="modal-header">
                        <h4 class="modal-title" id="addressModalLabel">Clear Loan </h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div><!-- End .modal-header -->
                    <div class="modal-body">

                        <h3>Are you sure you want to clear this loan?</h3>
                        <p>
                            Total Clear Loan: <?= formatNaira($newRepayment) ?> <br>
                            Clearing Fee: <?= formatNaira(10000) ?> <br>

                            Total : <?= formatNaira($newRepayment + 10000) ?> <br>
                        </p>



                        <input type="hidden" name="amount" value="<?= ceil($newRepayment) ?>" class="form-control">

                        <input type="hidden" name="link" value="view?loanid=<?php echo $loanid ?>&key=<?= $id ?>">
                        <input type="hidden" name="userid" value="<?php echo $id ?>">
                        <input type="hidden" name="name" value="<?php echo $name ?>">
                        <input type="hidden" name="email" value="<?php echo $email ?>">
                        <input type="hidden" name="loadId" value="<?php echo $rid ?>">


                        <input type="hidden" name="intialDuration" value="<?php echo $loans['spreadPeriod'] ?>">
                        <input type="hidden" name="currentDuration" value="<?php echo $newCount ?>">
                        <input type="hidden" name="totalLoanPaid" value="<?php echo ceil($loans['totalPayment']) ?>">
                        <input type="hidden" name="amountApply" value="<?php echo $loans['amountApply'] ?>">

                    </div><!-- End .modal-body -->
                    <div class="modal-footer">
                        <button type="button" class="btn btn-link btn-sm" data-dismiss="modal">Close</button>

                        <button type="submit" name="clearLoan" value="Create" class="btn btn-primary btn-sm">Yes, Clear</button>
                    </div><!-- End .modal-footer -->
                </form>
            </div><!-- End .modal-content -->
        </div><!-- End .modal-dialog -->
    </div>


    <script src="assets/node_modules/Magnific-Popup-master/dist/jquery.magnific-popup.min.js"></script>
    <script src="assets/node_modules/Magnific-Popup-master/dist/jquery.magnific-popup-init.js"></script>
    <script>
        $(document).ready(function() {

            $(document).on('click', "#print", function() {
                var mode = 'iframe'; //popup
                var close = mode == "popup";
                var options = {
                    mode: mode,
                    popClose: close
                };
                $(".no-print").hide();
                $("div.printableArea").printArea(options);
                setTimeout(function() {
                    $(".no-print").show();
                }, 1000);
            });

            $(document).on('click', "#loan", function() {
                var mode = 'iframe'; //popup
                var close = mode == "popup";
                var options = {
                    mode: mode,
                    popClose: close
                };
                $("#loan").html('Please wait...');
                $("div.printLoan").printArea(options);
                $("#loan").html('Print Loan History');

            });
        });
    </script>

    <script>
        function printHiddenSection() {
            var section = document.getElementById('printSection');

            // Temporarily display the section
            section.style.display = 'block';

            // Create a new window for printing
            var printWindow = window.open('', '_blank', 'width=600,height=600');
            printWindow.document.open();
            printWindow.document.write('<html><head><title>Print</title></head><body>');
            printWindow.document.write(section.innerHTML); // Print only the section content
            printWindow.document.write('</body></html>');
            printWindow.document.close();

            // Print the content
            printWindow.print();

            // After printing, hide the section again
            section.style.display = 'none';
        }
    </script>
</body>


</html>